<template>
  <q-field v-if="tab === 'name-main'" label="Название CRM">
    <q-input v-model="nameCrm" :model-value="nameCrm"/>
  </q-field>
  <div v-else-if="tab === 'notice-main'">
    <div v-if="!notice.length" class="flex items-center column align-items-center">
      <p class="text-xl text-center my-4">Обьявлений нет</p>
      <q-btn label="Добавить" color="green" class="mx-auto" icon-right="add" @click="addNotice" />
    </div>
    <div v-else class="pb-16 flex column">
      <q-list bordered style="max-width: 100%">
        <q-item v-for="(n, i) in notice" :key="n" class="q-my-sm" clickable v-ripple>
          <q-item-section avatar>
            <q-avatar color="primary" text-color="white">
            </q-avatar>
          </q-item-section>

          <q-item-section>
            <q-item-label><span v-if="n.name" class="opacity-70 mr-3 text-xs">{{n.name}}</span>{{n.title}}</q-item-label>
            <q-item-label caption lines="1" class="mb-6">{{n.comments}}</q-item-label>
            <q-item-label caption lines="2">Дата создания: {{formattedDate(n.createdAt)}}</q-item-label>
          </q-item-section>

          <q-item-section side>
            <q-icon :name="n.see && 'visibility' || 'visibility_off'" :color="n.see && 'green' || 'grey'" >
              <q-tooltip>{{n.see && 'Активно' || 'Скрыто'}}</q-tooltip>
            </q-icon>
          </q-item-section>
          <q-item-section side>
            <q-btn @click="deleteNotice(n._id, i)" round icon="delete" flat color="grey" />
          </q-item-section>
        </q-item>
      </q-list>
      <q-btn label="Добавить" color="green" class="mx-auto my-10 w-1/3" icon-right="add" @click="dialogNewNotice = true" >
        <q-dialog v-model="dialogNewNotice">
          <q-card class="w-1/2 px-4">
            <q-input label="Название обьявления" :model-value="newNotice.name" v-model="newNotice.name" />
            <q-input label="Заголовок обьвяления" :model-value="newNotice.title" v-model="newNotice.title" />
            <q-input label="Текст обьвяления" type="textarea" :model-value="newNotice.comments" v-model="newNotice.comments"  class="mb-6"/>
            <div class="flex column items-center">
              <div class="q-pa-md h-50 sm:w-full md:w-100 lg:w-1/2 rounded my-6 flex no-wrap"
                   :class="{'opacity-10':!newNotice.see}"
                   :style="{backgroundColor: newNotice.background, color: newNotice.color}"
              >
                <div>
                  <p class="mb-2 text-xl">{{newNotice.title}}</p>
                  <i class="text-sm">{{newNotice.comments}}</i>
                </div>
                <q-separator vertical class="mx-4"/>
                <q-btn label="Закрыть" />
              </div>
              <div class="flex items-center justify-around">
                <div class="flex items-center mx-4">
                  Цвет текста
                  <q-btn flat round icon="palette">
                    <q-menu auto-close>
                      <q-color
                          v-model="newNotice.color"
                          no-header
                          no-footer
                          default-view="palette"
                          class="my-picker"
                      />
                    </q-menu>
                  </q-btn>
                </div>
                <div class="flex items-center mx-4">
                  Цвет блока
                  <q-btn flat round icon="palette">
                    <q-menu auto-close>
                      <q-color
                          v-model="newNotice.background"
                          no-header
                          no-footer
                          default-view="palette"
                          class="my-picker"
                      />
                    </q-menu>
                  </q-btn>
                </div>

                <div class="flex items-center">
                  <p class="">Показывать:</p>
                  <q-toggle v-model="newNotice.see" :model-value="newNotice.see"/>
                </div>
              </div>
            </div>
            <q-btn label="Сохранить" @click="addNotice" class="my-6 float-right" />
          </q-card>
        </q-dialog>
      </q-btn>
    </div>
  </div>
</template>

<script>
import {ref} from 'vue'
import api from "../../API/api";
import Modal from "../../components/Modal.vue";
import formattedDate from "../../utils/formatDate";

export default {
  name: "Main-setting",
  components: {Modal},
  props: {
    tab: {type: String},
  },
  setup (prop, {emit}) {
    const notice = ref([])
    const newNotice = ref({
      background: '#292929',
      color: '#ffffff',
      comments: 'Текст обьявления',
      name: 'Название',
      see: true,
      title: 'Заголовок',
      views: [],
    })
    const dialogNewNotice = ref(false)
    api.getLeadInfo().then(res => res.data.leadInfo.length && (notice.value = res.data.leadInfo))
    async function addNotice () {
      await api.addLeadInfo(newNotice.value)
        .then(() => {
          notice.value.push(newNotice.value)
          dialogNewNotice.value = false
        })
    }
    async function changeNotice () {
      await api.changeLeadInfo(notice.value[0])
    }
    async function deleteNotice (_id, index) {
      await api.deleteLeadInfo({_id})
        .then(() => notice.value.splice(index, 1))
    }
    return {
      nameCrm: 'CRM Автоюрист',
      dialogNewNotice,
      formattedDate,
      notice,
      newNotice,
      addNotice,
      changeNotice,
      deleteNotice,
    }
  }
}
</script>

<style scoped>

</style>